close all;clear all
gr=groot;gr.ShowHiddenHandles='on';
fig=uifigure;
sub22(1)=uiaxes(fig);%これは多分4つの方向のグラフを作成する
sub22(2)=uiaxes(fig);
sub22(3)=uiaxes(fig);
sub22(4)=uiaxes(fig);
set(sub22(1),'Units','normalized','Position',[0.1300 0.5838 0.3347 0.3412])
set(sub22(2),'Units','normalized','Position',[0.5703 0.5838 0.3347 0.3412])
set(sub22(3),'Units','normalized','Position',[0.1300 0.1100 0.3347 0.3412])
set(sub22(4),'Units','normalized','Position',[0.5703 0.1100 0.3347 0.3412])

viewagl=[-37.5,30;0,90;90,0;0,0];%これは4つのグラフの角度を変更？

n=62;
l=1; %一辺の長さ
lg=l/2;%重心位置
th=zeros(1,n);

x=5;%正五角形から5

%同次変換座標行列の定義より、arm(1)の重心lgは、関節が動いてもlgの位置には作用しない。

%原点
arm(61).th=th(61);arm(61).a=[0;0;1];arm(61).l=[0;0;0];arm(61).lg=arm(61).l/2;
arm(61).parent=0;

%回転表示用の軸
arm(62).th=-18/180*pi;arm(62).a=[0;0;1];arm(62).l=[l*(cos(pi*72/180))/(4*cos(pi*72/180));-l*(sin(pi*72/180))/(4*cos(pi*72/180));-l*2/(4*sqrt(5)*cos(pi*72/180))];arm(62).lg=arm(62).l/2;
arm(62).parent=61;

for i=1:5 %底面
	arm(i).th=th(i);arm(i).a=[l*cos(2*pi*(i)/5);l*sin(2*pi*(i)/5);0];arm(i).l=[l*cos(2*pi*i/5);l*sin(2*pi*i/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(1).parent=62;
end

for i=6:10 %第一層1
	arm(i).th=th(i);arm(i).a=[-l*cos(2*pi*(i-1)/5);-l*sin(2*pi*(i-1)/5);0];arm(i).l=[-l*cos(2*pi*(i-1)/5);-l*sin(2*pi*(i-1)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(6).parent=5;
end

for i=11:15 %第一層2
	arm(i).th=th(i);arm(i).a=[-l*cos(2*pi*(i-2)/5);-l*sin(2*pi*(i-2)/5);0];arm(i).l=[-l*cos(2*pi*(i-2)/5);-l*sin(2*pi*(i-2)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(11).parent=4;
end

for i=16:20 %第一層3
	arm(i).th=th(i);arm(i).a=[-l*cos(2*pi*(i-3)/5);-l*sin(2*pi*(i-3)/5);0];arm(i).l=[-l*cos(2*pi*(i-3)/5);-l*sin(2*pi*(i-3)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(16).parent=3;
end

for i=21:25 %第一層4
	arm(i).th=th(i);arm(i).a=[-l*cos(2*pi*(i-4)/5);-l*sin(2*pi*(i-4)/5);0];arm(i).l=[-l*cos(2*pi*(i-4)/5);-l*sin(2*pi*(i-4)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(21).parent=2;
end

for i=26:30 %第一層5
	arm(i).th=th(i);arm(i).a=[-l*cos(2*pi*(i-5)/5);-l*sin(2*pi*(i-5)/5);0];arm(i).l=[-l*cos(2*pi*(i-5)/5);-l*sin(2*pi*(i-5)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(26).parent=1;
end

for i=31:35 %第二層1
	arm(i).th=th(i);arm(i).a=[l*cos(2*pi*(i+1)/5);l*sin(2*pi*(i+1)/5);0];arm(i).l=[l*cos(2*pi*(i+1)/5);l*sin(2*pi*(i+1)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(31).parent=8;
end

for i=36:40 %第二層2
	arm(i).th=th(i);arm(i).a=[l*cos(2*pi*i/5);l*sin(2*pi*i/5);0];arm(i).l=[l*cos(2*pi*i/5);l*sin(2*pi*i/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(36).parent=13;
end

for i=41:45 %第二層3
	arm(i).th=th(i);arm(i).a=[l*cos(2*pi*(i-1)/5);l*sin(2*pi*(i-1)/5);0];arm(i).l=[l*cos(2*pi*(i-1)/5);l*sin(2*pi*(i-1)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(41).parent=18;
end

for i=46:50 %第二層4
	arm(i).th=th(i);arm(i).a=[l*cos(2*pi*(i-2)/5);l*sin(2*pi*(i-2)/5);0];arm(i).l=[l*cos(2*pi*(i-2)/5);l*sin(2*pi*(i-2)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(46).parent=23;
end

for i=51:55 %第二層5
	arm(i).th=th(i);arm(i).a=[l*cos(2*pi*(i-3)/5);l*sin(2*pi*(i-3)/5);0];arm(i).l=[l*cos(2*pi*(i-3)/5);l*sin(2*pi*(i-3)/5);0];arm(i).lg=arm(i).l/2;
    arm(i).parent=i-1;
    arm(51).parent=28;
end

for i=56:60 %上面
	arm(i).th=th(i);arm(i).a=[-l*cos(2*pi*(i-2)/5);-l*sin(2*pi*(i-2)/5);0];arm(i).l=[-l*cos(2*pi*(i-2)/5);-l*sin(2*pi*(i-2)/5);0];arm(i).lg=arm(i).l/2;arm(i).parent=i-1;
    arm(56).parent=33;
end



%ベース

% define arm list structure アームの親決定

%for i=1:n;arm(i).parent=i-1;end

% 子リンクを接続し双方向リンクとする。
arm=vectest9makechildlink(arm);

ind=vectest9findallchildren(arm);
arm=vectest9kinematics(arm,ind);
plot1=[];
plot1=vectest9plot2021(arm,plot1,sub22);
fig2=uifigure;
ui=vectest9makeui2021(arm,'vectest9sub2021;',fig2);

%動作について
b1=uibutton(fig2,'Position',[400,270,120,60]);b2=uibutton(fig2,'Position',[400,200,120,60]);b3=uibutton(fig2,'Position',[400,130,120,60]);b4=uibutton(fig2,'Position',[400,60,120,60]);
b1.Text='rotation';b2.Text='up_sketch';b3.Text='down_sketch';b4.Text='development_view';
b1.ButtonPushedFcn='motion=''rotation'';motion_button';
b2.ButtonPushedFcn='motion=''up_sketch'';motion_button';
b3.ButtonPushedFcn='motion=''down_sketch'';motion_button';
b4.ButtonPushedFcn='motion=''development_view'';motion_button';